/*
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.sm.textual.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import no.ntnu.tdt4250.sm.textual.ide.contentassist.antlr.internal.InternalStateMachineDSLParser;
import no.ntnu.tdt4250.sm.textual.services.StateMachineDSLGrammarAccess;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class StateMachineDSLParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(StateMachineDSLGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, StateMachineDSLGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getEStringAccess().getAlternatives(), "rule__EString__Alternatives");
			builder.put(grammarAccess.getSMAccess().getGroup(), "rule__SM__Group__0");
			builder.put(grammarAccess.getSMAccess().getGroup_17(), "rule__SM__Group_17__0");
			builder.put(grammarAccess.getStateAccess().getGroup(), "rule__State__Group__0");
			builder.put(grammarAccess.getStateAccess().getGroup_1(), "rule__State__Group_1__0");
			builder.put(grammarAccess.getStateAccess().getGroup_1_2(), "rule__State__Group_1_2__0");
			builder.put(grammarAccess.getTransitionAccess().getGroup(), "rule__Transition__Group__0");
			builder.put(grammarAccess.getSMAccess().getNameAssignment_1(), "rule__SM__NameAssignment_1");
			builder.put(grammarAccess.getSMAccess().getStateAssignment_4(), "rule__SM__StateAssignment_4");
			builder.put(grammarAccess.getSMAccess().getStateAssignment_5(), "rule__SM__StateAssignment_5");
			builder.put(grammarAccess.getSMAccess().getTransitionAssignment_9(), "rule__SM__TransitionAssignment_9");
			builder.put(grammarAccess.getSMAccess().getTransitionAssignment_10(), "rule__SM__TransitionAssignment_10");
			builder.put(grammarAccess.getSMAccess().getInitialAssignment_13(), "rule__SM__InitialAssignment_13");
			builder.put(grammarAccess.getSMAccess().getFinalAssignment_16(), "rule__SM__FinalAssignment_16");
			builder.put(grammarAccess.getSMAccess().getFinalAssignment_17_1(), "rule__SM__FinalAssignment_17_1");
			builder.put(grammarAccess.getStateAccess().getNameAssignment_0(), "rule__State__NameAssignment_0");
			builder.put(grammarAccess.getStateAccess().getChildrenAssignment_1_1(), "rule__State__ChildrenAssignment_1_1");
			builder.put(grammarAccess.getStateAccess().getChildrenAssignment_1_2_1(), "rule__State__ChildrenAssignment_1_2_1");
			builder.put(grammarAccess.getTransitionAccess().getNameAssignment_0(), "rule__Transition__NameAssignment_0");
			builder.put(grammarAccess.getTransitionAccess().getSourceAssignment_2(), "rule__Transition__SourceAssignment_2");
			builder.put(grammarAccess.getTransitionAccess().getTargetAssignment_4(), "rule__Transition__TargetAssignment_4");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private StateMachineDSLGrammarAccess grammarAccess;

	@Override
	protected InternalStateMachineDSLParser createParser() {
		InternalStateMachineDSLParser result = new InternalStateMachineDSLParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public StateMachineDSLGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(StateMachineDSLGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
